
#include <inarm.h>
#include <stdio.h>
#include <iolpc2888.h>
#include <lpc288x_low_init.h>
#include "flash_lpc.h"
#include "sdram_lpc.h"
#include "test.h"

volatile unsigned long dly=0;

/*************************************************************************
 * Function Name: main
 * Parameters: none
 *
 * Return: none
 *
 * Description: main
 *
 *************************************************************************/
void main(void)
{

  // Led HIGH
  MODE0_2_bit.P2_1 = 1;
  MODE1_2_bit.P2_1 = 1;

  // Extension test
  // printf("\nTest extension port begin");
  // TestExt();
  // printf("\nTest extension OK!!!");
  // TestAnalog();

/*
  // power up procedure
  DDACCTRL_bit.DDAC_PD = 1;
  while(DDACSTAT_bit.PDOWN !=1);
  DDACSET_bit.LDYNPON = 1;
  DDACSET_bit.RDYNPON = 1;
  DDACCTRL_bit.DDAC_PD = 0;
  while(DDACSTAT_bit.MUTED);

  DDACSET = 0x00001300;

  L16OUT2 = 0x3FFF;
  R16OUT2 = 0x3FFF;

  while(1);
*/

  // Init SDRAM Controller
  InitSDRAMCtrl();

  // SDRAM Test
  printf("\nSDRAM test begin...");
  SDRAM_check();
  printf("\nTest SDRAM OK!!!");

  // Init Flash Controler
  InitFlashCtrl();

  // Flash Test
  printf("\nFLASH test begin...");
  Flash_check();
  printf("\nFLASH test OK!!!");

  // loop forever
  while(1)
  {
    // Led HIGH
    MODE0_2_bit.P2_1 = 1;
    MODE1_2_bit.P2_1 = 1;

    // delay
    for(dly=0; dly<50000; dly++);

    // Led LOW
    MODE0_2_bit.P2_1 = 0;
    MODE1_2_bit.P2_1 = 1;

    // delay
    for(dly=0; dly<50000; dly++);
  }
}
